      PROGRAM TDGELS
*
*       ணࠬ PDGELS
*
      include 'mpif.h'
*  ⠭ - ࠬ 
      INTEGER           DLEN_, IA, JA, IB, JB, N, NB, RSRC, CSRC,
     $                  MXLLDA, MXLLDB, NRHS, NBRHS, LWORK,
     $                  NOUT, MXLOCR, MXLOCC, MXRHSC
      PARAMETER         ( DLEN_ = 9, IA = 1, JA = 1, IB = 1, JB = 1,
     $                  M = 6, N = 5, MB = 2, NB = 2, RSRC = 0,
     $                  CSRC = 0, MXLLDA = 5, LWORK = 18,
*     $                  CSRC = 0, MXLLDA = 5, LWORK = -1,
     $                  MXLLDB = 5, NRHS = 1, NBRHS = 1, NOUT = 6,
     $                  MXLOCR = 5, MXLOCC = 4, MXRHSC = 1 )
*
      CHARACTER         TRANS
      PARAMETER         ( TRANS = 'N' )
*
*  ६
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
*
*  ᨢ
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ )
      DOUBLE PRECISION   A( MXLLDA, MXLOCC ), B( MXLLDB, MXRHSC ),
     $                   WORK( LWORK ), WORK1( NB )
*     $                   WORK( 18 ), WORK1( NB )
*
* 譨 ணࠬ
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   DESCINIT, PDMATINIT, PDGELS,
     $                   PDLAPRNT, SL_INIT
*
* ७ 㭪樨
      INTRINSIC          DBLE
*
*   DATA
      DATA               NPROW / 2 / , NPCOL / 3 /
*
* 믮塞 
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      CALL DESCINIT( DESCA, M, N, MB, NB, RSRC, CSRC, ICTXT, MXLLDA,
     $               INFO )
      CALL DESCINIT( DESCB, M, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDB, INFO )
*
*   A  B  ।  ⪥ ᮢ
*
      CALL PDMATINIT( M, N, A, IA, JA, DESCA, B, IB, JB, DESCB, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )M, N, MB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9984 ) TRANS
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) ' A'
      END IF
 9985 FORMAT( / 9I5 /)
 9984 FORMAT( / ' TRANS = ', A1 /)
*
      CALL PDLAPRNT( M, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
      WRITE( NOUT, FMT = * ) ' B'
      END IF
      CALL PDLAPRNT( M, NRHS, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1)
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL PDGELS( TRANS, M, N, NRHS, A, IA, JA, DESCA,
     $              B, IB, JB, DESCB, WORK, LWORK, INFO )
*
*  १⮢ X 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
*         WRITE( NOUT, FMT = 9986 )WORK(1)
         WRITE( NOUT, FMT = * ) '襭 X'
      END IF
*
      CALL PDLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'X', NOUT, WORK1)
*
* ᢮ ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '   ணࠬ PDGELS' )
 9998 FORMAT(/' 襭 A X = B ,'//'  A -  ',I2,' ',I2,',',
     $       /'      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( ' ய  ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
* 9986 FORMAT( / ' WORK(1)  = ', D16.5 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( M, N, A, IA, JA, DESCA, B, IB, JB, DESCB,
     $                      INFO )
*
* PDMATINIT   ।  A  B
*          ⪥ ᮢ 2 x 3
*
* ࠬ
      INTEGER            IA, IB, INFO, JA, JB, M, N
      INTEGER            DESCA( * ), DESCB( * )
      DOUBLE PRECISION   A( * ), B( * )
*
*  ६
      INTEGER            I, J
      DOUBLE PRECISION   AIJ
*
* 譨 ணࠬ
      EXTERNAL           PDELSET
*
* 믮塞 
*
      INFO = 0
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF(JA .NE.1) THEN
         INFO = -4
      END IF
*
       CALL PDELSET( A, 1, 1, DESCA, 36.0D0 )
       CALL PDELSET( A, 2, 2, DESCA, 14700.0D0 )
       CALL PDELSET( A, 3, 3, DESCA, 564480.0D0 )
       CALL PDELSET( A, 4, 4, DESCA, 3628800.0D0 )
       CALL PDELSET( A, 5, 5, DESCA, 4410000.0D0 )
*
      I = 6
      DO 3 J = 1, 5
         IF( J.EQ.1 ) AIJ = -2772.0D0
         IF( J.EQ.2 ) AIJ = 83160.0D0
         IF( J.EQ.3 ) AIJ = -582120.0D0
         IF( J.EQ.4 ) AIJ = 1552320.0D0
         IF( J.EQ.5 ) AIJ = -1746360.0D0
         CALL PDELSET( A, I, J, DESCA, AIJ )
    3 CONTINUE
*
      CALL PDELSET( A, 1, 2 ,DESCA, -630.0D0 )
      CALL PDELSET( A, 2, 1 ,DESCA, -630.0D0 )
      CALL PDELSET( A, 1, 3 ,DESCA, 3360.0D0 )
      CALL PDELSET( A, 3, 1 ,DESCA, 3360.0D0 )
      CALL PDELSET( A, 1, 4 ,DESCA, -7560.0D0 )
      CALL PDELSET( A, 4, 1 ,DESCA, -7560.0D0 )
      CALL PDELSET( A, 1, 5 ,DESCA, 7560.0D0 )
      CALL PDELSET( A, 5, 1 ,DESCA, 7560.0D0 )
      CALL PDELSET( A, 2, 3 ,DESCA, -88200.0D0 )
      CALL PDELSET( A, 3, 2 ,DESCA, -88200.0D0 )
      CALL PDELSET( A, 2, 4 ,DESCA, 211680.0D0 )
      CALL PDELSET( A, 4, 2 ,DESCA, 211680.0D0 )
      CALL PDELSET( A, 2, 5 ,DESCA, -220500.0D0 )
      CALL PDELSET( A, 5, 2 ,DESCA, -220500.0D0 )
      CALL PDELSET( A, 3, 4 ,DESCA, -1411200.0D0 )
      CALL PDELSET( A, 4, 3 ,DESCA, -1411200.0D0 )
      CALL PDELSET( A, 3, 5 ,DESCA, 1512000.0D0 )
      CALL PDELSET( A, 5, 3 ,DESCA, 1512000.0D0 )
      CALL PDELSET( A, 4, 5 ,DESCA, -3969000.0D0 )
      CALL PDELSET( A, 5, 4 ,DESCA, -3969000.0D0 )
*
      CALL PDELSET( B, 1, 1, DESCB, 463.0D0 )
      CALL PDELSET( B, 2, 1, DESCB, -13860.0D0 )
      CALL PDELSET( B, 3, 1, DESCB, 97020.0D0 )
      CALL PDELSET( B, 4, 1, DESCB, -258720.0D0 )
      CALL PDELSET( B, 5, 1, DESCB, 291060.0D0 )
      CALL PDELSET( B, 6, 1, DESCB, -116424.0D0 )
*
      RETURN
      END
